; Atari display module.  Procedure Handle_TIA is called every time the
; screen registers are changed.

; Set the following line to 1 for 160x200 mode, 0 for 320x200 mode

LOWRES EQU 0

VSYNC   EQU   0
VBLANK  EQU   1
WSYNC   EQU   2
RSYNC   EQU   3
NUSIZ0  EQU   4
NUSIZ1  EQU   5
COLUP0  EQU   6
COLUP1  EQU   7
COLUPF  EQU   8
COLUBK  EQU   9
CTRLPF  EQU   0Ah
REFP0   EQU   0Bh
REFP1   EQU   0Ch
PF0     EQU   0Dh
PF1     EQU   0Eh
PF2     EQU   0Fh
RESP0   EQU   10h
RESP1   EQU   11h
RESM0   EQU   12h
RESM1   EQU   13h
RESBL   EQU   14h
GRP0    EQU   1Bh
GRP1    EQU   1Ch
ENAM0   EQU   1Dh
ENAM1   EQU   1Eh
ENABL   EQU   1Fh
HMP0    EQU   20h
HMP1    EQU   21h
HMM0    EQU   22h
HMM1    EQU   23h
HMBL    EQU   24h
VDELP0  EQU   25h
VDELP1  EQU   26h
VDELBL  EQU   27h
RESMP0  EQU   28h
RESMP1  EQU   29h
HMOVE   EQU   2Ah
HMCLR   EQU   2Bh
CXCLR   EQU   2Ch
SWCHA1  EQU   280h
SWACNT1 EQU   281h
SWCHB1  EQU   282h
SWBCNT1 EQU   283h
INTTIM1 EQU   284h
TIM1T1  EQU   294h
TIM2T1  EQU   295h
TIM3T1  EQU   296h
TIM4T1  EQU   297h
SWCHA2  EQU   380h
SWACNT2 EQU   381h
SWCHB2  EQU   382h
SWBCNT2 EQU   383h
INTTIM2 EQU   384h
TIM1T2  EQU   394h
TIM2T2  EQU   395h
TIM3T2  EQU   396h
TIM4T2  EQU   397h

Player0Set  EQU 2
Player1Set  EQU 4
Missile0Set EQU 8
Missile1Set EQU 16
BallSet     EQU 32

P0CBase EQU   07D8Fh
P1CBase EQU   08D7Fh
M0CBase EQU   0FE33h
M1CBase EQU   032FFh
PFCBase EQU   0D7D5h
BLCBase EQU   0EBE9h  ; was EBEBh

data segment byte public 'data'
assume DS:data
        extrn TIA_Regs            : byte
        extrn TIA_Count           : byte
        extrn Old_TIA_Count       : byte
        extrn ObjectLoc           : byte
        extrn ObjectPix           : byte
        extrn Player0Size         : byte
        extrn Player1Size         : byte
        extrn Player0Size160      : byte
        extrn Player1Size160      : byte
        extrn Player0Size128      : byte
        extrn Player1Size128      : byte
        extrn Missile0SizeNum     : byte
        extrn Missile1SizeNum     : byte
        extrn MissileTable        : byte
        extrn Addr                : byte
        extrn BitSwap             : byte
        extrn Limit               : byte
        extrn ColorLum            : byte
        extrn ByteShift           : byte
        extrn Missile0Size        : byte
        extrn Missile1Size        : byte
        extrn Missile0Size160     : byte
        extrn Missile1Size160     : byte
        extrn BallSize            : byte
        extrn BallSize160         : byte
        extrn BitTest             : byte
        extrn CLW                 : byte
        extrn CRW                 : byte
        extrn Input_Byte          : byte
        extrn TIA_Scan            : byte
        extrn Handle_TIA_Jump     : byte
        extrn Handle_TIA_Jump_Set : byte
        extrn DispJump            : byte
        extrn DoHMOVE             : byte
        extrn OldDoHMOVE          : byte
        extrn LineStart           : byte
        extrn LastScan            : byte
        extrn NewScan             : byte
        extrn TopVBLANK           : byte
        extrn CTRLPFLatch         : byte
        extrn CTRLPFScan          : byte
        extrn CTRLPFCount         : byte
        extrn MissileSize         : byte
        extrn BallAdjust          : byte
        extrn Config              : byte
        extrn AtariSeg            : byte
        extrn MaxRows             : byte
        extrn Sep1                : byte
        extrn Sep2                : byte
        extrn Add1                : byte
        extrn Add2                : byte
        extrn Add3                : byte
        extrn Missile0SizeNumAdd  : byte
        extrn Missile1SizeNumAdd  : byte
        extrn PlayerSize          : byte
        extrn Missile0Wrap        : byte
        extrn Missile1Wrap        : byte

;        extrn GRP0Latch           : byte
;        extrn GRP1Latch           : byte
;        extrn GRP0Write           : byte
;        extrn GRP1Write           : byte
data ends

code segment para public 'code'
assume DS:data,CS:code

public Handle_TIA

.486

; -------------------------------------------------------------------------
; Display player 0 and missile 0
; -------------------------------------------------------------------------
_P0M0   macro
        local Show0,GetOut1,ShowM0,GetOut3,GetOut3a,Show1,Show1a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut1
        JNZ   SHORT Show0
        ADD   WORD PTR ObjectPix[Player0Set * 2],160
Show0:
        ADD   BX,WORD PTR Player0Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP0]
        JZ    SHORT GetOut1
        MOV   BX,WORD PTR ColorLum[0]
        MOV   WORD PTR ES:[DI],BX

  ; Display missile 0

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        JMP   SHORT GetOut3a
GetOut1:
        AND   SI,P0CBase

  ; Display missile 0

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1a
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1a:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        MOV   BX,WORD PTR ColorLum[0]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut3a
GetOut3:
        AND   SI,M0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display player 0 and missile 0 for 160x200 mode
; -------------------------------------------------------------------------
_P0M0_160   macro
        local Show0,GetOut1,ShowM0,GetOut3,GetOut3a,Show1,Show1a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut1
        JNZ   SHORT Show0
        ADD   WORD PTR ObjectPix[Player0Set * 2],160
Show0:
        ADD   BX,WORD PTR Player0Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP0]
        JZ    SHORT GetOut1
        MOV   BL,BYTE PTR ColorLum[0]
        MOV   BYTE PTR ES:[DI],BL

  ; Display missile 0

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        JMP   SHORT GetOut3a
GetOut1:
        AND   SI,P0CBase

  ; Display missile 0

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1a
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1a:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        MOV   BL,BYTE PTR ColorLum[0]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut3a
GetOut3:
        AND   SI,M0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display player 0
; -------------------------------------------------------------------------
_P0     macro
        local Show0,GetOut1,GetOut3a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut1
        JNZ   SHORT Show0
        ADD   WORD PTR ObjectPix[Player0Set * 2],160
Show0:
        ADD   BX,WORD PTR Player0Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP0]
        JZ    SHORT GetOut1
        MOV   BX,WORD PTR ColorLum[0]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut3a
GetOut1:
        AND   SI,P0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display player 0 for 160x200 mode
; -------------------------------------------------------------------------
_P0_160  macro
        local Show0,GetOut1,GetOut3a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut1
        JNZ   SHORT Show0
        ADD   WORD PTR ObjectPix[Player0Set * 2],160
Show0:
        ADD   BX,WORD PTR Player0Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP0]
        JZ    SHORT GetOut1
        MOV   BL,BYTE PTR ColorLum[0]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut3a
GetOut1:
        AND   SI,P0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display missile 0
; -------------------------------------------------------------------------
_M0     macro
        local ShowM0,GetOut3,GetOut3a,Show1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        MOV   BX,WORD PTR ColorLum[0]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut3a
GetOut3:
        AND   SI,M0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display missile 0 for 160x200 mode
; -------------------------------------------------------------------------
_M0_160  macro
        local ShowM0,GetOut3,GetOut3a,Show1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile0Set * 2]
        CMP   BX,WORD PTR Player0Size
        JA    SHORT GetOut3
        JNZ   SHORT Show1
;        ADD   WORD PTR ObjectPix[Missile0Set * 2],160
        MOV   DX,WORD PTR Missile0Wrap
        ADD   WORD PTR ObjectPix[Missile0Set * 2],DX
        DEC   DH
Show1:
        ADD   BX,WORD PTR Missile0SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut3
        MOV   BL,BYTE PTR ColorLum[0]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut3a
GetOut3:
        AND   SI,M0CBase
GetOut3a:
        endm


; -------------------------------------------------------------------------
; Display player 1 and missile 1
; -------------------------------------------------------------------------
_P1M1   macro
        local Show1,GetOut2,ShowM1,GetOut4,GetOut4a,Show2,Show2a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut2
        JNZ   SHORT Show1
        ADD   WORD PTR ObjectPix[Player1Set * 2],160
Show1:
        ADD   BX,WORD PTR Player1Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP1]
        JZ    SHORT GetOut2
        MOV   BX,WORD PTR ColorLum[2]
        MOV   WORD PTR ES:[DI],BX

  ; Display missile 1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        JMP   SHORT GetOut4a
GetOut2:
        AND   SI,P1CBase

  ; Display missile 1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2a
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2a:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        MOV   BX,WORD PTR ColorLum[2]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut4a
GetOut4:
        AND   SI,M1CBase
GetOut4a:
        endm


; -------------------------------------------------------------------------
; Display player 1 and missile 1 for 160x200 mode
; -------------------------------------------------------------------------
_P1M1_160   macro
        local Show1,GetOut2,ShowM1,GetOut4,GetOut4a,Show2,Show2a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut2
        JNZ   SHORT Show1
        ADD   WORD PTR ObjectPix[Player1Set * 2],160
Show1:
        ADD   BX,WORD PTR Player1Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP1]
        JZ    SHORT GetOut2
        MOV   BL,BYTE PTR ColorLum[2]
        MOV   BYTE PTR ES:[DI],BL

  ; Display missile 1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        JMP   SHORT GetOut4a
GetOut2:
        AND   SI,P1CBase

  ; Display missile 1

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2a
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2a:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        MOV   BL,BYTE PTR ColorLum[2]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut4a
GetOut4:
        AND   SI,M1CBase
GetOut4a:
        endm


; -------------------------------------------------------------------------
; Display player 1
; -------------------------------------------------------------------------
_P1     macro
        local Show1,GetOut2,GetOut4a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut2
        JNZ   SHORT Show1
        ADD   WORD PTR ObjectPix[Player1Set * 2],160
Show1:
        ADD   BX,WORD PTR Player1Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP1]
        JZ    SHORT GetOut2
        MOV   BX,WORD PTR ColorLum[2]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut4a
GetOut2:
        AND   SI,P1CBase
GetOut4a:
        endm


; -------------------------------------------------------------------------
; Display player 1 for 160x200 mode
; -------------------------------------------------------------------------
_P1_160  macro
        local Show1,GetOut2,GetOut4a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Player1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut2
        JNZ   SHORT Show1
        ADD   WORD PTR ObjectPix[Player1Set * 2],160
Show1:
        ADD   BX,WORD PTR Player1Size128
        MOV   DL,BYTE PTR ByteShift[BX]
        TEST  DL,BYTE PTR TIA_Regs[GRP1]
        JZ    SHORT GetOut2
        MOV   BL,BYTE PTR ColorLum[2]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut4a
GetOut2:
        AND   SI,P1CBase
GetOut4a:
        endm


; -------------------------------------------------------------------------
; Display missile 1
; -------------------------------------------------------------------------
_M1     macro
        local ShowM1,GetOut4,GetOut4a,Show2a

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2a
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2a:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        MOV   BX,WORD PTR ColorLum[2]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut4a
GetOut4:
        AND   SI,M1CBase
GetOut4a:
        endm

; -------------------------------------------------------------------------
; Display missile 1 for 160x200 mode
; -------------------------------------------------------------------------
_M1_160  macro
        local ShowM1,GetOut4,GetOut4a,Show2a

        MOV   BX,AX
        SUB   BX,WORD PTR ObjectPix[Missile1Set * 2]
        CMP   BX,WORD PTR Player1Size
        JA    SHORT GetOut4
        JNZ   SHORT Show2a
;        ADD   WORD PTR ObjectPix[Missile1Set * 2],160
        MOV   DX,WORD PTR Missile1Wrap
        ADD   WORD PTR ObjectPix[Missile1Set * 2],DX
        DEC   DH
Show2a:
        ADD   BX,WORD PTR Missile1SizeNum
        TEST  BYTE PTR MissileTable[BX],DH ; 0FFh
        JZ    SHORT GetOut4
        MOV   BL,BYTE PTR ColorLum[2]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut4a
GetOut4:
        AND   SI,M1CBase
GetOut4a:
        endm


; -------------------------------------------------------------------------
; Display ball
; -------------------------------------------------------------------------
_BL     macro
        local ShowBL,GetOut5,GetOut5a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectLoc[BallSet * 2]
        CMP   BX,WORD PTR BallSize
        JB    SHORT ShowBL
        CMP   BX,WORD PTR BallSize160
        JGE   SHORT GetOut5
ShowBL:
        MOV   BX,WORD PTR ColorLum[4]
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut5a
GetOut5:
        AND   SI,BLCBase
GetOut5a:
        endm

; -------------------------------------------------------------------------
; Display ball for 160x200 mode
; -------------------------------------------------------------------------
_BL_160  macro
        local ShowBL,GetOut5,GetOut5a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectLoc[BallSet * 2]
        CMP   BX,WORD PTR BallSize
        JB    SHORT ShowBL
        CMP   BX,WORD PTR BallSize160
        JGE   SHORT GetOut5
ShowBL:
        MOV   BL,BYTE PTR ColorLum[4]
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut5a
GetOut5:
        AND   SI,BLCBase
GetOut5a:
        endm

; -------------------------------------------------------------------------
; Display ball
; -------------------------------------------------------------------------
_BL1st  macro
        local ShowBL,GetOut5,GetOut5a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectLoc[BallSet * 2]
        CMP   BX,WORD PTR BallSize
        JB    SHORT ShowBL
        CMP   BX,WORD PTR BallSize160
        JGE   SHORT GetOut5
ShowBL:
        MOV   BX,WORD PTR ColorLum[4]
        JMP   SHORT GetOut5a
GetOut5:
        MOV   BX,WORD PTR ColorLum[6]
        AND   SI,BLCBase
GetOut5a:
        MOV   WORD PTR ES:[DI],BX
        endm

; -------------------------------------------------------------------------
; Display ball for 160x200 mode
; -------------------------------------------------------------------------
_BL_1601st  macro
        local ShowBL,GetOut5,GetOut5a
        MOV   BX,AX
        SUB   BX,WORD PTR ObjectLoc[BallSet * 2]
        CMP   BX,WORD PTR BallSize
        JB    SHORT ShowBL
        CMP   BX,WORD PTR BallSize160
        JGE   SHORT GetOut5
ShowBL:
        MOV   BL,BYTE PTR ColorLum[4]
        JMP   SHORT GetOut5a
GetOut5:
        MOV   BL,BYTE PTR ColorLum[6]
        AND   SI,BLCBase
GetOut5a:
        MOV   BYTE PTR ES:[DI],BL
        endm


; -------------------------------------------------------------------------
; Display playfield before anything else
; -------------------------------------------------------------------------
_PF1st  macro
        local L1,L2,GetOut
        MOV   BL,AL
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   BX,WORD PTR CLW
;        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut
L1:
        MOV   BX,WORD PTR CRW
;        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut
L2:
        MOV   BX,WORD PTR ColorLum[6]
        AND   SI,PFCBase
GetOut:
        MOV   WORD PTR ES:[DI],BX
        endm


; -------------------------------------------------------------------------
; Display playfield before anything else for 160x200 mode
; -------------------------------------------------------------------------
_PF1st_160  macro
        local L1,L2,GetOut
        MOV   BL,AL
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   BL,BYTE PTR CLW
;        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut
L1:
        MOV   BL,BYTE PTR CRW
;        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut
L2:
        MOV   BL,BYTE PTR ColorLum[6]
        AND   SI,PFCBase
GetOut:
        MOV   BYTE PTR ES:[DI],BL
        endm


; -------------------------------------------------------------------------
; Display playfield after everything else
; -------------------------------------------------------------------------
_PFlast macro
        local L1,L2,Getout
        MOV   BL,AL
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   BX,WORD PTR CLW
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut
L1:
        MOV   BX,WORD PTR CRW
        MOV   WORD PTR ES:[DI],BX
        JMP   SHORT GetOut
L2:
        AND   SI,PFCBase
GetOut:
        endm


; -------------------------------------------------------------------------
; Display playfield after everything else for 160x200 mode
; -------------------------------------------------------------------------
_PFlast_160 macro
        local L1,L2,Getout
        MOV   BL,AL
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   BL,BYTE PTR CLW
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut
L1:
        MOV   BL,BYTE PTR CRW
        MOV   BYTE PTR ES:[DI],BL
        JMP   SHORT GetOut
L2:
        AND   SI,PFCBase
GetOut:
        endm


; -------------------------------------------------------------------------
; Display loop
; -------------------------------------------------------------------------
_Disp   macro Collision,P0,M0,P1,M1,Ball
        local Top1,Top
        TEST  BYTE PTR TIA_Regs[CTRLPF],4
        JZ    Top
Top1:
        MOV   SI,Collision                    ; Set up collision counter
        MOV   BX,WORD PTR ColorLum[6] ; Default: background color
        MOV   WORD PTR ES:[DI],BX
        if P1 ne 0
          if M1 ne 0
          _P1M1
          else
          _P1
          endif
        else
          if M1 ne 0
          _M1
          endif
        endif
        if P0 ne 0
          if M0 ne 0
          _P0M0
          else
          _P0
          endif
        else
          if M0 ne 0
          _M0
          endif
        endif
        _PFlast
        if Ball ne 0
        _BL
        endif
        ADD   DI,2                            ; Write pixel and move on
        OR    BP,SI                           ; Tally collisions
        INC   AL                              ; Next pixel
        CMP   AL,BYTE PTR Limit
        JB    Top1
        JMP   @Exiting
Top:
        MOV   SI,Collision                    ; Set up collision counter
        _PF1st
        if Ball ne 0
        _BL
        endif
        if P1 ne 0
          if M1 ne 0
          _P1M1
          else
          _P1
          endif
        else
          if M1 ne 0
          _M1
          endif
        endif
        if P0 ne 0
          if M0 ne 0
          _P0M0
          else
          _P0
          endif
        else
          if M0 ne 0
          _M0
          endif
        endif
        ADD   DI,2                            ; Write pixel and move on
        OR    BP,SI                           ; Tally collisions
        INC   AL                              ; Next pixel
        CMP   AL,BYTE PTR Limit
        JB    Top
        endm


; -------------------------------------------------------------------------
; Display loop for 160x200 mode
; -------------------------------------------------------------------------
_Disp160   macro Collision,P0,M0,P1,M1,Ball
        local Top1,Top
        TEST  BYTE PTR TIA_Regs[CTRLPF],4
        JZ    Top
Top1:
        MOV   SI,Collision                    ; Set up collision counter
        MOV   BL,BYTE PTR ColorLum[6] ; Default: background color
        MOV   BYTE PTR ES:[DI],BL
        if P1 ne 0
          if M1 ne 0
          _P1M1_160
          else
          _P1_160
          endif
        else
          if M1 ne 0
          _M1_160
          endif
        endif
        if P0 ne 0
          if M0 ne 0
          _P0M0_160
          else
          _P0_160
          endif
        else
          if M0 ne 0
          _M0_160
          endif
        endif
        _PFlast_160
        if Ball ne 0
        _BL_160
        endif
        INC   DI                              ; Write pixel and move on
        OR    BP,SI                           ; Tally collisions
        INC   AL                              ; Next pixel
        CMP   AL,BYTE PTR Limit
        JB    Top1
        JMP   @Exiting
Top:
        MOV   SI,Collision                    ; Set up collision counter
        _PF1st_160
        if Ball ne 0
        _BL_160
        endif
        if P1 ne 0
          if M1 ne 0
          _P1M1_160
          else
          _P1_160
          endif
        else
          if M1 ne 0
          _M1_160
          endif
        endif
        if P0 ne 0
          if M0 ne 0
          _P0M0_160
          else
          _P0_160
          endif
        else
          if M0 ne 0
          _M0_160
          endif
        endif
        INC   DI                              ; Write pixel and move on
        OR    BP,SI                           ; Tally collisions
        INC   AL                              ; Next pixel
        CMP   AL,BYTE PTR Limit
        JB    Top
        endm


; -------------------------------------------------------------------------
; Display loop, used for playfield only
; -------------------------------------------------------------------------
_DispNothingLoop macro
        local L2A,NoPix,Outside,Leaving,Lt1,Lt2,Lt3,Lt1No,Lt2No,Lt3No,Outside1,Lt0,Lt0No

        SUB   AH,AL

        MOV   BL,AL
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT NoPix
        MOV   BL,AL               ; Playfield is displayed
        AND   AL,0FCh
        AND   BL,3
        JZ    SHORT Outside1
        CMP   BL,1
        JZ    SHORT Lt1
        CMP   BL,2
        JZ    SHORT Lt2
        JMP   SHORT Lt3
NoPix:
        MOV   BL,AL               ; Background is displayed
        AND   AL,0FCh
        AND   BL,3
        JZ    SHORT L2A
        CMP   BL,1
        JZ    SHORT Lt1No
        CMP   BL,2
        JZ    Lt2No
        JMP   Lt3No
Outside:
        MOV   BL,AL
        ADD   AL,4
        TEST  ECX,DWORD PTR BitTest[BX + 4]
        JZ    SHORT L2A
Outside1:
        TEST  AH,0FCh
        JZ    SHORT Lt0
        MOV   DWORD PTR ES:[DI],EDX
        MOV   DWORD PTR ES:[DI + 4],EDX
        ADD   DI,8
        SUB   AH,4
        JNZ   SHORT Outside
        JZ    SHORT Leaving
Lt0:
        MOV   WORD PTR ES:[DI],DX
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt1:
        MOV   WORD PTR ES:[DI],DX
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt2:
        MOV   WORD PTR ES:[DI],DX
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt3:
        MOV   WORD PTR ES:[DI],DX
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JNZ   SHORT Outside
;        OR    BP,1
;        JMP   @Exiting
        JMP   Leaving
L2A:
        TEST  AH,0FCh
        JZ    SHORT Lt0No
        MOV   DWORD PTR ES:[DI],ESI
        MOV   DWORD PTR ES:[DI + 4],ESI
        ADD   DI,8
        SUB   AH,4
        JNZ   SHORT Outside
        JZ    SHORT Leaving
Lt0No:
        MOV   WORD PTR ES:[DI],SI
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt1No:
        MOV   WORD PTR ES:[DI],SI
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt2No:
        MOV   WORD PTR ES:[DI],SI
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt3No:
        MOV   WORD PTR ES:[DI],SI
        ADD   DI,2                            ; Write pixel and move on
        DEC   AH
        JNZ   Outside
Leaving:
        OR    BP,1
        endm


; -------------------------------------------------------------------------
; Display loop, used for playfield only for 160x200 mode
; -------------------------------------------------------------------------
_DispNothingLoop160 macro
        local L2A,NoPix,Outside,Leaving,Lt1,Lt2,Lt3,Lt1No,Lt2No,Lt3No,Outside1,Lt0,Lt0No

        SUB   AH,AL

        MOV   BL,AL
        AND   BX,01FCh
        TEST  ESI,DWORD PTR BitTest[BX]
        JZ    SHORT NoPix
        MOV   BL,AL               ; Playfield is displayed
        AND   AL,0FCh
        AND   BL,3
        JZ    SHORT Outside1
        CMP   BL,1
        JZ    SHORT Lt1
        CMP   BL,2
        JZ    SHORT Lt2
        JMP   SHORT Lt3
NoPix:
        MOV   BL,AL               ; Background is displayed
        AND   AL,0FCh
        AND   BL,3
        JZ    SHORT L2A
        CMP   BL,1
        JZ    SHORT Lt1No
        CMP   BL,2
        JZ    Lt2No
        JMP   Lt3No
Outside:
        MOV   BL,AL
        ADD   AL,4
        TEST  ESI,DWORD PTR BitTest[BX + 4]
        JZ    SHORT L2A
Outside1:
        TEST  AH,0FCh
        JZ    SHORT Lt0
        MOV   DWORD PTR ES:[DI],EDX
        ADD   DI,4
        SUB   AH,4
        JNZ   SHORT Outside
        JZ    SHORT Leaving
Lt0:
        MOV   BYTE PTR ES:[DI],DL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt1:
        MOV   BYTE PTR ES:[DI],DL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt2:
        MOV   BYTE PTR ES:[DI],DL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt3:
        MOV   BYTE PTR ES:[DI],DL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JNZ   SHORT Outside
;        OR    BP,1
;        JMP   @Exiting
        JMP   Leaving
L2A:
        TEST  AH,0FCh
        JZ    SHORT Lt0No
        MOV   DWORD PTR ES:[DI],ECX
        ADD   DI,4
        SUB   AH,4
        JNZ   SHORT Outside
        JZ    SHORT Leaving
Lt0No:
        MOV   BYTE PTR ES:[DI],CL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt1No:
        MOV   BYTE PTR ES:[DI],CL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt2No:
        MOV   BYTE PTR ES:[DI],CL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JZ    SHORT Leaving
Lt3No:
        MOV   BYTE PTR ES:[DI],CL
        INC   DI                              ; Write pixel and move on
        DEC   AH
        JNZ   Outside
Leaving:
        OR    BP,1
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only
; -------------------------------------------------------------------------
_DispNothingX  macro
        local Top,L1,L2,Top1,TopA
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        CMP   AL,80
        JAE   SHORT Top1
        MOV   EDX,DWORD PTR CLW
Top:
        MOV   BL,AL
        AND   BX,01FCh
        TEST  ECX,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   WORD PTR ES:[DI],DX

        ADD   DI,2                            ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT Top
        OR    BP,1
        JMP   @Exiting
L1:
        MOV   EDX,DWORD PTR CRW
        MOV   WORD PTR ES:[DI],DX

        ADD   DI,2                            ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT TopA
        OR    BP,1
        JMP   @Exiting
L2:
        MOV   WORD PTR ES:[DI],SI
        ADD   DI,2                            ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT Top
        OR    BP,1
        JMP   @Exiting

  ; Draws right side of screen: pixel 80 and up

Top1:
        MOV   EDX,DWORD PTR CRW
TopA:
        _DispNothingLoop
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only for 160x200 mode
; -------------------------------------------------------------------------
_DispNothing  macro
        local Top1,L1
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        CMP   AL,80
        JAE   Top1
        MOV   EDX,DWORD PTR CLW
        PUSH  AX
        CMP   AH,80
        JBE   L1
        MOV   AH,80
L1:
        _DispNothingLoop
        POP   AX
        CMP   AH,80
        JBE   @Exiting
        MOV   AL,80
Top1:
        MOV   EDX,DWORD PTR CRW
        _DispNothingLoop
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only for 160x200 mode
; -------------------------------------------------------------------------
_DispNothing160X  macro
        local Top,L1,L2,Top1,TopA
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        XCHG  ESI,ECX
        CMP   AL,80
        JAE   SHORT Top1
        MOV   EDX,DWORD PTR CLW
Top:
        MOV   BL,AL
        AND   BX,01FCh
        TEST  ESI,DWORD PTR BitTest[BX]
        JZ    SHORT L2
        CMP   AL,80
        JAE   SHORT L1
        MOV   BYTE PTR ES:[DI],DL

        INC   DI                              ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT Top
        OR    BP,1
        JMP   @Exiting
L1:
        MOV   EDX,DWORD PTR CRW
        MOV   BYTE PTR ES:[DI],DL

        INC   DI                              ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT TopA
        OR    BP,1
        JMP   @Exiting
L2:
        MOV   BYTE PTR ES:[DI],CL
        INC   DI                              ; Write pixel and move on
        INC   AL                              ; Next pixel
        CMP   AL,AH
        JB    SHORT Top
        OR    BP,1
        JMP   @Exiting

  ; Draws right side of screen: pixel 80 and up

Top1:
        MOV   EDX,DWORD PTR CRW
TopA:
        _DispNothingLoop160
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only for 160x200 mode
; -------------------------------------------------------------------------
_DispNothing160  macro
        local Top1,L1
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        XCHG  ESI,ECX
        CMP   AL,80
        JAE   Top1
        MOV   EDX,DWORD PTR CLW
        PUSH  AX
        CMP   AH,80
        JBE   L1
        MOV   AH,80
L1:
        _DispNothingLoop160
        POP   AX
        CMP   AH,80
        JBE   @Exiting
        MOV   AL,80
Top1:
        MOV   EDX,DWORD PTR CRW
        _DispNothingLoop160
        endm



; -------------------------------------------------------------------------
; Display loop -- special case; playfield only (left side)
; -------------------------------------------------------------------------
_DispLeftNothing  macro
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        MOV   EDX,DWORD PTR CLW
        _DispNothingLoop
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only (left side) for 160x200 mode
; -------------------------------------------------------------------------
_DispLeftNothing160  macro
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        XCHG  ESI,ECX
        MOV   EDX,DWORD PTR CLW
        _DispNothingLoop160
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only (right side)
; -------------------------------------------------------------------------
_DispRightNothing  macro
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        MOV   EDX,DWORD PTR CRW
        _DispNothingLoop
        endm


; -------------------------------------------------------------------------
; Display loop -- special case; playfield only (right side) for 160x200 mode
; -------------------------------------------------------------------------
_DispRightNothing160  macro
        MOV   BH,BYTE PTR TIA_Regs[CTRLPF]
        MOV   AH,BYTE PTR Limit
        MOV   SI,WORD PTR ColorLum[6]
        BSWAP ESI
        MOV   SI,WORD PTR ColorLum[6]
        XCHG  ECX,ESI
        MOV   EDX,DWORD PTR CRW
        _DispNothingLoop160
        endm


; -------------------------------------------------------------------------

align   16
Handle_TIA proc far

        TEST  BYTE PTR TIA_Regs[VBLANK],2
        JZ    SHORT @TestOk1


        MOV   AX,WORD PTR TIA_Scan
        CMP   AX,WORD PTR NewScan
        JGE   SHORT @ExitP1
        JMP   SHORT @TestOk1
@ExitP1:
        MOV   AX,WORD PTR LastScan
        MOV   WORD PTR NewScan,AX


        JMP   @ExitP
@TestOk1:
        MOV   AX,WORD PTR TIA_Count
        CMP   AX,WORD PTR Old_TIA_Count
        JG    SHORT @TestOk2

;        MOV   AX,WORD PTR Old_TIA_Count
;        MOV   WORD PTR TIA_Count,AX

        JMP   @ExitP
@TestOk2:
        OR    AX,AX
        JNS   SHORT @TestOk3
        JMP   @ExitP
@TestOk3:
        MOV   AL,BYTE PTR MaxRows
        CMP   BYTE PTR TIA_Scan,AL ;200
        JAE   @ExitP

  ; We're going to use BP as a general-purpose register; there MUST NOT
  ; be any local variables!!!

        PUSH  BP

  ; Set up collision total

        SUB   BP,BP

  ; Fill the jump table if it hasn't been filled yet

        TEST  BYTE PTR Handle_TIA_Jump_Set,0FFh
        JNZ   @JumpTableSet
IF LOWRES EQ 0
        MOV   WORD PTR Handle_TIA_Jump[00h * 2],OFFSET DoNothing
        MOV   WORD PTR Handle_TIA_Jump[01h * 2],OFFSET DoBL
        MOV   WORD PTR Handle_TIA_Jump[02h * 2],OFFSET DoM1
        MOV   WORD PTR Handle_TIA_Jump[03h * 2],OFFSET DoM1BL
        MOV   WORD PTR Handle_TIA_Jump[04h * 2],OFFSET DoP1
        MOV   WORD PTR Handle_TIA_Jump[05h * 2],OFFSET DoP1BL
        MOV   WORD PTR Handle_TIA_Jump[06h * 2],OFFSET DoM1P1
        MOV   WORD PTR Handle_TIA_Jump[07h * 2],OFFSET DoM1P1BL
        MOV   WORD PTR Handle_TIA_Jump[08h * 2],OFFSET DoM0
        MOV   WORD PTR Handle_TIA_Jump[09h * 2],OFFSET DoM0BL
        MOV   WORD PTR Handle_TIA_Jump[0Ah * 2],OFFSET DoM0M1
        MOV   WORD PTR Handle_TIA_Jump[0Bh * 2],OFFSET DoM0M1BL
        MOV   WORD PTR Handle_TIA_Jump[0Ch * 2],OFFSET DoM0P1
        MOV   WORD PTR Handle_TIA_Jump[0Dh * 2],OFFSET DoM0P1BL
        MOV   WORD PTR Handle_TIA_Jump[0Eh * 2],OFFSET DoM0P1M1
        MOV   WORD PTR Handle_TIA_Jump[0Fh * 2],OFFSET DoM0P1M1BL
        MOV   WORD PTR Handle_TIA_Jump[10h * 2],OFFSET DoP0
        MOV   WORD PTR Handle_TIA_Jump[11h * 2],OFFSET DoP0BL
        MOV   WORD PTR Handle_TIA_Jump[12h * 2],OFFSET DoP0M1
        MOV   WORD PTR Handle_TIA_Jump[13h * 2],OFFSET DoP0M1BL
        MOV   WORD PTR Handle_TIA_Jump[14h * 2],OFFSET DoP0P1
        MOV   WORD PTR Handle_TIA_Jump[15h * 2],OFFSET DoP0P1BL
        MOV   WORD PTR Handle_TIA_Jump[16h * 2],OFFSET DoP0P1M1
        MOV   WORD PTR Handle_TIA_Jump[17h * 2],OFFSET DoP0P1M1BL
        MOV   WORD PTR Handle_TIA_Jump[18h * 2],OFFSET DoP0M0
        MOV   WORD PTR Handle_TIA_Jump[19h * 2],OFFSET DoP0M0BL
        MOV   WORD PTR Handle_TIA_Jump[1Ah * 2],OFFSET DoP0M0M1
        MOV   WORD PTR Handle_TIA_Jump[1Bh * 2],OFFSET DoP0M0M1BL
        MOV   WORD PTR Handle_TIA_Jump[1Ch * 2],OFFSET DoP0M0P1
        MOV   WORD PTR Handle_TIA_Jump[1Dh * 2],OFFSET DoP0M0P1BL
        MOV   WORD PTR Handle_TIA_Jump[1Eh * 2],OFFSET DoP0M0P1M1
        MOV   WORD PTR Handle_TIA_Jump[1Fh * 2],OFFSET DoP0M0P1M1BL
ELSE
        MOV   WORD PTR Handle_TIA_Jump[00h * 2],OFFSET DoNothing160
        MOV   WORD PTR Handle_TIA_Jump[01h * 2],OFFSET DoBL160
        MOV   WORD PTR Handle_TIA_Jump[02h * 2],OFFSET DoM1160
        MOV   WORD PTR Handle_TIA_Jump[03h * 2],OFFSET DoM1BL160
        MOV   WORD PTR Handle_TIA_Jump[04h * 2],OFFSET DoP1160
        MOV   WORD PTR Handle_TIA_Jump[05h * 2],OFFSET DoP1BL160
        MOV   WORD PTR Handle_TIA_Jump[06h * 2],OFFSET DoM1P1160
        MOV   WORD PTR Handle_TIA_Jump[07h * 2],OFFSET DoM1P1BL160
        MOV   WORD PTR Handle_TIA_Jump[08h * 2],OFFSET DoM0160
        MOV   WORD PTR Handle_TIA_Jump[09h * 2],OFFSET DoM0BL160
        MOV   WORD PTR Handle_TIA_Jump[0Ah * 2],OFFSET DoM0M1160
        MOV   WORD PTR Handle_TIA_Jump[0Bh * 2],OFFSET DoM0M1BL160
        MOV   WORD PTR Handle_TIA_Jump[0Ch * 2],OFFSET DoM0P1160
        MOV   WORD PTR Handle_TIA_Jump[0Dh * 2],OFFSET DoM0P1BL160
        MOV   WORD PTR Handle_TIA_Jump[0Eh * 2],OFFSET DoM0P1M1160
        MOV   WORD PTR Handle_TIA_Jump[0Fh * 2],OFFSET DoM0P1M1BL160
        MOV   WORD PTR Handle_TIA_Jump[10h * 2],OFFSET DoP0160
        MOV   WORD PTR Handle_TIA_Jump[11h * 2],OFFSET DoP0BL160
        MOV   WORD PTR Handle_TIA_Jump[12h * 2],OFFSET DoP0M1160
        MOV   WORD PTR Handle_TIA_Jump[13h * 2],OFFSET DoP0M1BL160
        MOV   WORD PTR Handle_TIA_Jump[14h * 2],OFFSET DoP0P1160
        MOV   WORD PTR Handle_TIA_Jump[15h * 2],OFFSET DoP0P1BL160
        MOV   WORD PTR Handle_TIA_Jump[16h * 2],OFFSET DoP0P1M1160
        MOV   WORD PTR Handle_TIA_Jump[17h * 2],OFFSET DoP0P1M1BL160
        MOV   WORD PTR Handle_TIA_Jump[18h * 2],OFFSET DoP0M0160
        MOV   WORD PTR Handle_TIA_Jump[19h * 2],OFFSET DoP0M0BL160
        MOV   WORD PTR Handle_TIA_Jump[1Ah * 2],OFFSET DoP0M0M1160
        MOV   WORD PTR Handle_TIA_Jump[1Bh * 2],OFFSET DoP0M0M1BL160
        MOV   WORD PTR Handle_TIA_Jump[1Ch * 2],OFFSET DoP0M0P1160
        MOV   WORD PTR Handle_TIA_Jump[1Dh * 2],OFFSET DoP0M0P1BL160
        MOV   WORD PTR Handle_TIA_Jump[1Eh * 2],OFFSET DoP0M0P1M1160
        MOV   WORD PTR Handle_TIA_Jump[1Fh * 2],OFFSET DoP0M0P1M1BL160
ENDIF
        MOV   BYTE PTR Handle_TIA_Jump_Set,1
@JumpTableSet:

  ; Check CTRLPF write delay

        MOV   AL,BYTE PTR CTRLPFLatch
        CMP   AL,BYTE PTR TIA_Regs[CTRLPF]
        JE    @NoCopy
        MOV   AX,WORD PTR TIA_Scan
        CMP   AX,WORD PTR CTRLPFScan
        JNE   SHORT @NewCTRLPF
        MOV   AX,WORD PTR TIA_Count
;        MOV   BX,0
;        CMP   AX,BX
;        JL    @ContCopy
;        MOV   BX,80
;        CMP   AX,BX
;        JL    @ContCopy
;        MOV   BX,160
;@ContCopy:
        MOV   BX,WORD PTR CTRLPFCount
        ADD   BX,64
        CMP   AX,BX
        JLE   @NoCopy

@DoCopy:

        ; Break up into two runs; pre-change and post-change

        PUSH  WORD PTR TIA_Count
        MOV   WORD PTR TIA_Count,BX
        CALL  Handle_TIA
        POP   WORD PTR TIA_Count

@NewCTRLPF:

        ; Copy CTRLPF from latch

        MOV   SI,CTRLPF
        MOV   AL,BYTE PTR CTRLPFLatch
        MOV   BYTE PTR AtariSeg[SI],AL
        MOV   BYTE PTR TIA_Regs[CTRLPF],AL

        ; Recall collisions from previous run

        MOV   AX,WORD PTR Input_Byte[6]
        AND   AX,0C080h
        MOV   BP,AX
        SHR   BP,2
        MOV   AX,WORD PTR Input_Byte[4]
        AND   AX,0C0C0h
        OR    BP,AX
        SHR   BP,2
        MOV   AX,WORD PTR Input_Byte[2]
        AND   AX,0C0C0h
        OR    BP,AX
        SHR   BP,2
        MOV   AX,WORD PTR Input_Byte[0]
        AND   AX,0C0C0h
        OR    BP,AX

        ; Act on the new CTRLPF

        MOV   AL,BYTE PTR TIA_Regs[CTRLPF]
        MOV   SI,AX
        SHR   SI,4
        AND   SI,3
        MOV   CL,BYTE PTR MissileSize[SI]
        SUB   CH,CH
        MOV   WORD PTR BallSize,CX

        MOV   DX,CX
        DEC   DX
        SHR   DX,1
        MOV   WORD PTR BallAdjust,DX

        SUB   CX,160
        MOV   WORD PTR BallSize160,CX
        MOV   CX,WORD PTR ColorLum[0]
        MOV   DX,WORD PTR ColorLum[2]
        MOV   BX,WORD PTR ColorLum[4]
        TEST  AL,2
        JZ    SHORT @LCPF1

        AND   AL,0Fh
        CMP   AL,0Fh
        JZ    SHORT @LCPF1

        MOV   WORD PTR CLW,CX
        MOV   WORD PTR CLW[2],CX
        MOV   WORD PTR CRW,DX
        MOV   WORD PTR CRW[2],DX
        JMP   SHORT @LCPF2
      @LCPF1:
        MOV   WORD PTR CLW,BX
        MOV   WORD PTR CLW[2],BX
        MOV   WORD PTR CRW,BX
        MOV   WORD PTR CRW[2],BX
      @LCPF2:

@NoCopy:


  ; Check to see if the GRP0 latch needs to be copied to the register

;        TEST  BYTE PTR TIA_Regs[VDELP0],1
;        JZ    @CheckP1Latch

;        MOV   BL,BYTE PTR GRP0Latch
;        MOV   SI,GRP0
;        CMP   BL,BYTE PTR AtariSeg[SI]
;        JE    @CheckP1Latch


;        MOV   BX,WORD PTR GRP0Write
;        CMP   WORD PTR Old_TIA_Count,BX
;        JE    @CopyGRP0Latch
;        JG    @CheckP1Latch
;        CMP   WORD PTR TIA_Count,BX
;        JLE   @CheckP1Latch

        ; Break up into two runs; pre-copy and post-copy

;        PUSH  WORD PTR TIA_Count
;        MOV   WORD PTR TIA_Count,BX
;        CALL  Handle_TIA
;        POP   WORD PTR TIA_Count

        ; Copy the latch to the reg

@CopyGRP0Latch:
;        MOV   AL,BYTE PTR GRP0Latch
;        MOV   SI,GRP0
;        MOV   BYTE PTR AtariSeg[SI],AL

;        MOV   SI,GRP0
;        MOV   AL,BYTE PTR AtariSeg[SI]
;        MOV   BYTE PTR GRP0Latch,AL


;        MOV   BYTE PTR TIA_Regs[GRP0],AL
;        AND   BYTE PTR DispJump,0DFh
;        TEST  AL,0FFh
;        JZ    @CheckP1Latch
;        OR    BYTE PTR DispJump,20h

  ; Check to see if the GRP1 latch needs to be copied to the register

@CheckP1Latch:

;        TEST  BYTE PTR TIA_Regs[VDELP1],1
;        JZ    @CheckWrapAround

;        MOV   BL,BYTE PTR GRP1Latch
;        MOV   SI,GRP1
;        CMP   BL,BYTE PTR AtariSeg[SI]
;        JE    @CheckWrapAround

;        MOV   BX,WORD PTR GRP1Write
;        CMP   WORD PTR Old_TIA_Count,BX
;        JE    @CopyGRP1Latch
;        JG    @CheckWrapAround
;        CMP   WORD PTR TIA_Count,BX
;        JLE   @CheckWrapAround

        ; Break up into two runs; pre-copy and post-copy

;        PUSH  WORD PTR TIA_Count
;        MOV   WORD PTR TIA_Count,BX
;        CALL  Handle_TIA
;        POP   WORD PTR TIA_Count

        ; Copy the latch to the reg

@CopyGRP1Latch:
;        MOV   AL,BYTE PTR GRP1Latch
;        MOV   SI,GRP1
;        MOV   BYTE PTR AtariSeg[SI],AL

;        MOV   SI,GRP1
;        MOV   AL,BYTE PTR AtariSeg[SI]
;        MOV   BYTE PTR GRP1Latch,AL


;        MOV   BYTE PTR TIA_Regs[GRP1],AL
;        AND   BYTE PTR DispJump,0F7h
;        TEST  AL,0FFh
;        JZ    @CheckWrapAround
;        OR    BYTE PTR DispJump,8
@CheckWrapAround:

  ; Check for wraparound

        MOV   CX,WORD PTR Old_TIA_Count
        CMP   CX,0
        JGE   SHORT @Positive
        SUB   CX,CX
@Positive:
        TEST  BYTE PTR DoHMOVE,1
        JZ    SHORT @HMOVEOkA
        CMP   CX,8
        JAE   SHORT @HMOVEOkA
        MOV   CX,8
@HMOVEOkA:

  ; Player 0

        MOV   AX,WORD PTR ObjectLoc[Player0Set * 2]
        MOV   BX,AX
        ADD   BX,WORD PTR Player0Size160
        JLE   SHORT @P0NotOk
        CMP   BX,CX ; WORD PTR Old_TIA_Count
        JL    SHORT @P0NotOk
        SUB   AX,160
@P0NotOk:
        MOV   WORD PTR ObjectPix[Player0Set * 2],AX
        CMP   BYTE PTR Player0Size,15
        JE    @P0Double
        CMP   BYTE PTR Player0Size,31
        JNE   @NoP0Add
@P0Double:
        INC   WORD PTR ObjectPix[Player0Set * 2]
@NoP0Add:

  ; Player 1

        MOV   AX,WORD PTR ObjectLoc[Player1Set * 2]
        MOV   BX,AX
        ADD   BX,WORD PTR Player1Size160
        JLE   SHORT @P1NotOk
        CMP   BX,CX ; WORD PTR Old_TIA_Count
        JL    SHORT @P1NotOk
        SUB   AX,160
@P1NotOk:
        MOV   WORD PTR ObjectPix[Player1Set * 2],AX
        CMP   BYTE PTR Player1Size,15
        JE    @P1Double
        CMP   BYTE PTR Player1Size,31
        JNE   @NoP1Add
@P1Double:
        INC   WORD PTR ObjectPix[Player1Set * 2]
@NoP1Add:

  ; Missile 0

        MOV   WORD PTR Missile0Wrap,0
        MOV   AX,WORD PTR ObjectLoc[Missile0Set * 2]
;        MOV   BX,AX
;        MOV   DI,WORD PTR Missile0Size
;        SHR   DI,1
;        ADD   BX,DI
;        CMP   BX,160
;        JL    @M0Ok
;        MOV   AX,-10
;@M0Ok:

        MOV   BX,AX
        ADD   BX,WORD PTR Player0Size160
;        ADD   BX,WORD PTR Missile0Size160
        JLE   SHORT @M0NotOk
        CMP   BX,CX ; WORD PTR Old_TIA_Count
        JL    SHORT @M0NotOk
        SUB   AX,160
        MOV   WORD PTR Missile0Wrap,160
@M0NotOk:
        MOV   WORD PTR ObjectPix[Missile0Set * 2],AX

  ; Missile 1

        MOV   WORD PTR Missile1Wrap,0
        MOV   AX,WORD PTR ObjectLoc[Missile1Set * 2]
;        MOV   BX,AX
;        MOV   DI,WORD PTR Missile1Size
;        SHR   DI,1
;        ADD   BX,DI
;        CMP   BX,160
;        JL    @M1Ok
;        MOV   AX,-10
;@M1Ok:

        MOV   BX,AX
        ADD   BX,WORD PTR Player1Size160
;        ADD   BX,WORD PTR Missile1Size160
        JLE   SHORT @M1NotOk
        CMP   BX,CX ; WORD PTR Old_TIA_Count
        JL    SHORT @M1NotOk
        SUB   AX,160
        MOV   WORD PTR Missile1Wrap,160
@M1NotOk:
        MOV   WORD PTR ObjectPix[Missile1Set * 2],AX

  ; Turn off any missiles that straddle the screen edge

;      ; ----------------------------------------
;        MOV   WORD PTR Missile0SizeNumAdd,0
;        CMP   WORD PTR ObjectPix[Missile0Set * 2],0
;        JL    @M0AddLeft
;        MOV   SI,WORD PTR Missile0SizeNum
;        AND   SI,0380h
;        SHR   SI,6
;        MOV   BX,160
;        SUB   BX,WORD PTR PlayerSize[SI]
;
;        CMP   WORD PTR ObjectPix[Missile0Set * 2],BX
;        JG    @M0AddRight
;        JMP   @M0AddContinue
;      ; ----------------------------------------
;      @M0AddLeft:
;        MOV   SI,WORD PTR Missile0SizeNum
;        MOV   AX,WORD PTR ObjectPix[Missile0Set * 2]
;        AND   SI,0380h
;        MOV   CX,WORD PTR Missile0Size
;        SHR   SI,6
;
;        OR    AX,AX
;        JGE   @M0AddContinue
;        ADD   CX,AX
;        JLE   @Ck2LM0
;        MOV   BX,WORD PTR Add1[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;        JMP   @M0AddContinue
;      @Ck2LM0:
;        ADD   AX,WORD PTR Sep1[SI]
;        JGE   @M0AddContinue
;        ADD   CX,WORD PTR Sep1[SI]
;        JLE   @Ck3LM0
;        MOV   BX,WORD PTR Add2[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;        JMP   @M0AddContinue
;      @Ck3LM0:
;        ADD   AX,WORD PTR Sep2[SI]
;        JGE   @M0AddContinue
;        ADD   CX,WORD PTR Sep2[SI]
;        JLE   @M0AddContinue
;        MOV   BX,WORD PTR Add3[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;        JMP   @M0AddContinue
;      ; ----------------------------------------
;      @M0AddRight:
;        MOV   DX,160
;        MOV   AX,WORD PTR ObjectPix[Missile0Set * 2]
;        SUB   DX,WORD PTR Missile0Size
;        MOV   CX,WORD PTR Missile0Size
;
;        CMP   AX,DX
;        JLE   @M0AddContinue
;        ADD   CX,AX
;        CMP   CX,160
;        JLE   @Ck2RM0
;        MOV   BX,WORD PTR Add1[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;        JMP   @M0AddContinue
;      @Ck2RM0:
;        ADD   AX,WORD PTR Sep1[SI]
;        ADD   CX,WORD PTR Sep1[SI]
;        CMP   CX,160
;        JLE   @Ck3RM0
;        CMP   AX,DX
;        JLE   @M0AddContinue
;        MOV   BX,WORD PTR Add2[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;        JMP   @M0AddContinue
;      @Ck3RM0:
;        ADD   AX,WORD PTR Sep2[SI]
;        ADD   CX,WORD PTR Sep2[SI]
;        CMP   CX,160
;        JLE   @M0AddContinue
;        CMP   AX,DX
;        JLE   @M0AddContinue
;        MOV   BX,WORD PTR Add3[SI]
;        MOV   WORD PTR Missile0SizeNumAdd,BX
;      @M0AddContinue:
;
;      ; ----------------------------------------
;        MOV   WORD PTR Missile1SizeNumAdd,0
;        CMP   WORD PTR ObjectPix[Missile1Set * 2],0
;        JL    @M1AddLeft
;        MOV   SI,WORD PTR Missile1SizeNum
;        AND   SI,0380h
;        SHR   SI,6
;        MOV   BX,160
;        SUB   BX,WORD PTR PlayerSize[SI]
;
;        CMP   WORD PTR ObjectPix[Missile1Set * 2],BX
;        JG    @M1AddRight
;        JMP   @M1AddContinue
;      ; ----------------------------------------
;      @M1AddLeft:
;        MOV   SI,WORD PTR Missile1SizeNum
;        MOV   AX,WORD PTR ObjectPix[Missile1Set * 2]
;        AND   SI,0380h
;        MOV   CX,WORD PTR Missile1Size
;        SHR   SI,6
;
;        OR    AX,AX
;        JGE   @M1AddContinue
;        ADD   CX,AX
;        JLE   @Ck2LM1
;        MOV   BX,WORD PTR Add1[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;        JMP   @M1AddContinue
;      @Ck2LM1:
;        ADD   AX,WORD PTR Sep1[SI]
;        JGE   @M1AddContinue
;        ADD   CX,WORD PTR Sep1[SI]
;        JLE   @Ck3LM1
;        MOV   BX,WORD PTR Add2[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;        JMP   @M1AddContinue
;      @Ck3LM1:
;        ADD   AX,WORD PTR Sep2[SI]
;        JGE   @M1AddContinue
;        ADD   CX,WORD PTR Sep2[SI]
;        JLE   @M1AddContinue
;        MOV   BX,WORD PTR Add3[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;        JMP   @M1AddContinue
;      ; ----------------------------------------
;      @M1AddRight:
;        MOV   DX,160
;        MOV   AX,WORD PTR ObjectPix[Missile1Set * 2]
;        SUB   DX,WORD PTR Missile1Size
;        MOV   CX,WORD PTR Missile1Size
;
;        CMP   AX,DX
;        JLE   @M1AddContinue
;        ADD   CX,AX
;        CMP   CX,160
;        JLE   @Ck2RM1
;        MOV   BX,WORD PTR Add1[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;        JMP   @M1AddContinue
;      @Ck2RM1:
;        ADD   AX,WORD PTR Sep1[SI]
;        ADD   CX,WORD PTR Sep1[SI]
;        CMP   CX,160
;        JLE   @Ck3RM1
;        CMP   AX,DX
;        JLE   @M1AddContinue
;        MOV   BX,WORD PTR Add2[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;        JMP   @M1AddContinue
;      @Ck3RM1:
;        ADD   AX,WORD PTR Sep2[SI]
;        ADD   CX,WORD PTR Sep2[SI]
;        CMP   CX,160
;        JLE   @M1AddContinue
;        CMP   AX,DX
;        JLE   @M1AddContinue
;        MOV   BX,WORD PTR Add3[SI]
;        MOV   WORD PTR Missile1SizeNumAdd,BX
;      @M1AddContinue:
;
;  ; Add to Missile0SizeNum/Missile1SizeNum
;
;        PUSH  WORD PTR Missile0SizeNum
;        PUSH  WORD PTR Missile1SizeNum
;        MOV   BX,WORD PTR Missile0SizeNumAdd
;        ADD   WORD PTR Missile0SizeNum,BX
;        MOV   BX,WORD PTR Missile1SizeNumAdd
;        ADD   WORD PTR Missile1SizeNum,BX

  ; Set up playfield data

        SUB   BH,BH
        MOV   BL,BYTE PTR TIA_Regs[PF0]
        MOV   CH,BYTE PTR BitSwap[BX]
        BSWAP ECX
        MOV   CH,BYTE PTR TIA_Regs[PF1]
        MOV   BL,BYTE PTR TIA_Regs[PF2]
        MOV   CL,BYTE PTR BitSwap[BX]

  ; Set up pointer to screen

        MOV   AX,0A000h
        MOV   ES,AX
        MOV   DI,WORD PTR Addr

  ; Set starting position

        MOV   AX,WORD PTR Old_TIA_Count
        OR    AX,AX
        JNS   SHORT @StartOk
        SUB   AX,AX
@StartOk:

  ; Loop across screen from Old_TIA_Count to TIA_Count - 1 or 159

        MOV   AH,BYTE PTR TIA_Count
        CMP   AH,160
        JBE   SHORT @AHOk
        MOV   AH,160
@AHOk:

  ; Check for 160x200 mode

;        TEST  BYTE PTR Config[31],0FFh
;        JZ    SHORT @No160x200A
;IF LOWRES EQ 1
;        SHR   DI,1
;ENDIF
;@No160x200A:


  ; See if the first 8 pixels need to be blanked out

        TEST  BYTE PTR DoHMOVE,1
        JZ    SHORT @HMOVEOk
        CMP   AL,8
        JAE   SHORT @HMOVEOk
        SUB   EBX,EBX
        MOV   SI,WORD PTR LineStart
        MOV   DWORD PTR ES:[SI],EBX
        MOV   DWORD PTR ES:[SI + 4],EBX
;        TEST  BYTE PTR Config[31],0FFh
;        JNZ   SHORT @No160x200B
IF LOWRES EQ 0
        MOV   DWORD PTR ES:[SI + 8],EBX
        MOV   DWORD PTR ES:[SI + 12],EBX
ENDIF
;@No160x200B:

        MOV   BL,AH
        CMP   BL,8
        JBE   SHORT @No
        MOV   BL,8
@No:
        SUB   BL,AL
        ADD   AL,BL
;        TEST  BYTE PTR Config[31],0FFh
;        JNZ   @No160x200C
IF LOWRES EQ 0
        ADD   BX,BX
ENDIF
;@No160x200C:
        ADD   DI,BX
;        JMP   @HMOVEDone
@HMOVEOk:
        CMP   AL,8
        JA    @HMOVEDone
        CMP   AH,8
        JB    @HMOVEDone
        MOV   BYTE PTR DoHMOVE,0
@HMOVEDone:
        CMP   AH,AL
        JNE   SHORT @NotSame
;        TEST  BYTE PTR Config[31],0FFh
;        JZ    @Exiting
;        JMP   @Exiting160
        JMP   @Exiting
@NotSame:

  ; If vertical blanking is on, output black

        TEST  BYTE PTR TIA_Regs[VBLANK],2
        JZ    SHORT @NotBlank
        TEST  BYTE PTR TopVBLANK,0FFh
        JNZ   SHORT @ContinueBlank
;        TEST  BYTE PTR Config[31],0FFh
;        JZ    @Exiting
;        JMP   @Exiting160
        JMP   @Exiting
;        JZ    SHORT @DoneFour
@ContinueBlank:
        CLD
        MOV   CL,AH
        SUB   CL,AL
        SUB   CH,CH
        SUB   EAX,EAX
;        TEST  BYTE PTR Config[31],0FFh
;        JZ    SHORT @No160x200D
IF LOWRES EQ 1
        TEST  CX,3
        JZ    SHORT @DoFourA
        MOV   BX,CX
        AND   CX,3
        REP   STOSB
        MOV   CX,BX
@DoFourA:
        SHR   CX,2
        OR    CX,CX
        JZ    SHORT @DoneFourA
        REP   STOSD
@DoneFourA:
;        JMP   @Exiting160
ELSE
;@No160x200D:
        TEST  CX,3
        JZ    SHORT @DoFour
        MOV   BX,CX
        AND   CX,3
        REP   STOSW
        MOV   CX,BX
@DoFour:
        SHR   CX,1
        AND   CX,0FFFEh
        OR    CX,CX
        JZ    SHORT @DoneFour
        REP   STOSD
@DoneFour:
ENDIF
        JMP   @Exiting

  ; Vertical blanking is off

@NotBlank:

        MOV   BYTE PTR Limit,AH
        SUB   AH,AH
        MOV   DH,0FFh

  ; Jump via the jump table

        MOV   BL,BYTE PTR DispJump
        SUB   BH,BH

;        TEST  BYTE PTR Config[31],0FFh
;        JZ    @No160x200E
;IF LOWRES EQ 1
;        ADD   BX,64
;ENDIF
;@No160x200E:
        JMP   WORD PTR Handle_TIA_Jump[BX]
IF LOWRES EQ 0
DoBL:

; -------------------------------------------------------------------------
; Displaying BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and M0CBase and M1CBase> 0 0 0 0 1
        JMP   @Exiting

DoM1BL:

; -------------------------------------------------------------------------
; Displaying M1 and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and M0CBase> 0 0 0 1 1
        JMP   @Exiting

DoM0BL:

; -------------------------------------------------------------------------
; Displaying M0 and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and M1CBase> 0 1 0 0 1
        JMP   @Exiting

DoM0M1BL:

; -------------------------------------------------------------------------
; Displaying M0,M1, and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase> 0 1 0 1 1
        JMP   @Exiting

DoP1BL:

; -------------------------------------------------------------------------
; Displaying P1 and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and M0CBase and M1CBase> 0 0 1 0 1
        JMP   @Exiting

DoM1P1BL:

; -------------------------------------------------------------------------
; Displaying P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and M0CBase> 0 0 1 1 1
        JMP   @Exiting

DoM0P1BL:

; -------------------------------------------------------------------------
; Displaying M0,P1, and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase and M1CBase> 0 1 1 0 1
        JMP   @Exiting

DoM0P1M1BL:

; -------------------------------------------------------------------------
; Displaying M0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp <P0CBase> 0 1 1 1 1
        JMP   @Exiting

DoP0BL:

; -------------------------------------------------------------------------
; Displaying P0 and BL
; -------------------------------------------------------------------------

        _Disp <P1CBase and M0CBase and M1CBase> 1 0 0 0 1
        JMP   @Exiting

DoP0M1BL:

; -------------------------------------------------------------------------
; Displaying P0,M1, and BL
; -------------------------------------------------------------------------

        _Disp <P1CBase and M0CBase> 1 0 0 1 1
        JMP   @Exiting

DoP0M0BL:

; -------------------------------------------------------------------------
; Displaying P0,M0, and BL
; -------------------------------------------------------------------------

        _Disp <P1CBase and M1CBase> 1 1 0 0 1
        JMP   @Exiting

DoP0M0M1BL:

; -------------------------------------------------------------------------
; Displaying P0,M0,M1, and BL
; -------------------------------------------------------------------------

        _Disp <P1CBase> 1 1 0 1 1
        JMP   @Exiting

DoP0P1BL:

; -------------------------------------------------------------------------
; Displaying P0,P1, and BL
; -------------------------------------------------------------------------

        _Disp <M0CBase and M1CBase> 1 0 1 0 1
        JMP   @Exiting

DoP0P1M1BL:

; -------------------------------------------------------------------------
; Displaying P0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp <M0CBase> 1 0 1 1 1
        JMP   @Exiting

DoP0M0P1BL:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1, and BL
; -------------------------------------------------------------------------

        _Disp <M1CBase> 1 1 1 0 1
        JMP   @Exiting

DoP0M0P1M1BL:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp <0FFFFh> 1 1 1 1 1
        JMP   @Exiting

DoNothing:

; -------------------------------------------------------------------------
; Displaying nothing (playfield only)
; -------------------------------------------------------------------------

        CMP   BYTE PTR Limit,80
        JAE   @MaybeRight
        _DispLeftNothing
        JMP   @Exiting
@MaybeRight:
        CMP   AL,80
        JAE   @OnlyRight
        _DispNothing
        JMP   @Exiting
@OnlyRight:
        _DispRightNothing
        JMP   @Exiting

;        _Disp <P0CBase and P1CBase and M0CBase and m1CBase and BLCBase> 0 0 0 0 0
;        JMP   @Exiting

DoM1:

; -------------------------------------------------------------------------
; Displaying M1
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and M0CBase and BLCBase> 0 0 0 1 0
        JMP   @Exiting

DoM0:

; -------------------------------------------------------------------------
; Displaying M0
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and M1CBase and BLCBase> 0 1 0 0 0
        JMP   @Exiting

DoM0M1:

; -------------------------------------------------------------------------
; Displaying M0 and M1
; -------------------------------------------------------------------------

        _Disp <P0CBase and P1CBase and BLCBase> 0 1 0 1 0
        JMP   @Exiting

DoP1:

; -------------------------------------------------------------------------
; Displaying P1
; -------------------------------------------------------------------------

        _Disp <P0CBase and M0CBase and M1CBase and BLCBase> 0 0 1 0 0
        JMP   @Exiting

DoM1P1:

; -------------------------------------------------------------------------
; Displaying P1 and M1
; -------------------------------------------------------------------------

        _Disp <P0CBase and M0CBase and BLCBase> 0 0 1 1 0
        JMP   @Exiting

DoM0P1:

; -------------------------------------------------------------------------
; Displaying M0 and P1
; -------------------------------------------------------------------------

        _Disp <P0CBase and M1CBase and BLCBase> 0 1 1 0 0
        JMP   @Exiting

DoM0P1M1:

; -------------------------------------------------------------------------
; Displaying M0,P1, and M1
; -------------------------------------------------------------------------

        _Disp <P0CBase and BLCBase> 0 1 1 1 0
        JMP   @Exiting

DoP0:

; -------------------------------------------------------------------------
; Displaying P0
; -------------------------------------------------------------------------

        _Disp <P1CBase and M0CBase and M1CBase and BLCBase> 1 0 0 0 0
        JMP   @Exiting

DoP0M1:

; -------------------------------------------------------------------------
; Displaying P0 and M1
; -------------------------------------------------------------------------

        _Disp <P1CBase and M0CBase and BLCBase> 1 0 0 1 0
        JMP   @Exiting

DoP0M0:

; -------------------------------------------------------------------------
; Displaying P0 and M0
; -------------------------------------------------------------------------

        _Disp <P1CBase and M1CBase and BLCBase> 1 1 0 0 0
        JMP   @Exiting

DoP0M0M1:

; -------------------------------------------------------------------------
; Displaying P0,M0, and M1
; -------------------------------------------------------------------------

        _Disp <P1CBase and BLCBase> 1 1 0 1 0
        JMP   @Exiting

DoP0P1:

; -------------------------------------------------------------------------
; Displaying P0 and P1
; -------------------------------------------------------------------------

        _Disp <M0CBase and M1CBase and BLCBase> 1 0 1 0 0
        JMP   @Exiting

DoP0P1M1:

; -------------------------------------------------------------------------
; Displaying P0,P1, and M1
; -------------------------------------------------------------------------

        _Disp <M0CBase and BLCBase> 1 0 1 1 0
        JMP   @Exiting

DoP0M0P1:

; -------------------------------------------------------------------------
; Displaying P0,M0, and P1
; -------------------------------------------------------------------------

        _Disp <M1CBase and BLCBase> 1 1 1 0 0
        JMP   @Exiting

DoP0M0P1M1:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1, and M1
; -------------------------------------------------------------------------

        _Disp <BLCBase> 1 1 1 1 0
;        JMP   @Exiting
ELSE
; -------------------------------------------------------------------------
; This code is used exclusively for 160x200x256 mode
; -------------------------------------------------------------------------

DoBL160:

; -------------------------------------------------------------------------
; Displaying BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and M0CBase and M1CBase> 0 0 0 0 1
        JMP   @Exiting

DoM1BL160:

; -------------------------------------------------------------------------
; Displaying M1 and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and M0CBase> 0 0 0 1 1
        JMP   @Exiting

DoM0BL160:

; -------------------------------------------------------------------------
; Displaying M0 and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and M1CBase> 0 1 0 0 1
        JMP   @Exiting

DoM0M1BL160:

; -------------------------------------------------------------------------
; Displaying M0,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase> 0 1 0 1 1
        JMP   @Exiting

DoP1BL160:

; -------------------------------------------------------------------------
; Displaying P1 and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M0CBase and M1CBase> 0 0 1 0 1
        JMP   @Exiting

DoM1P1BL160:

; -------------------------------------------------------------------------
; Displaying P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M0CBase> 0 0 1 1 1
        JMP   @Exiting

DoM0P1BL160:

; -------------------------------------------------------------------------
; Displaying M0,P1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M1CBase> 0 1 1 0 1
        JMP   @Exiting

DoM0P1M1BL160:

; -------------------------------------------------------------------------
; Displaying M0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P0CBase> 0 1 1 1 1
        JMP   @Exiting

DoP0BL160:

; -------------------------------------------------------------------------
; Displaying P0 and BL
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M0CBase and M1CBase> 1 0 0 0 1
        JMP   @Exiting

DoP0M1BL160:

; -------------------------------------------------------------------------
; Displaying P0,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M0CBase> 1 0 0 1 1
        JMP   @Exiting

DoP0M0BL160:

; -------------------------------------------------------------------------
; Displaying P0,M0, and BL
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M1CBase> 1 1 0 0 1
        JMP   @Exiting

DoP0M0M1BL160:

; -------------------------------------------------------------------------
; Displaying P0,M0,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <P1CBase> 1 1 0 1 1
        JMP   @Exiting

DoP0P1BL160:

; -------------------------------------------------------------------------
; Displaying P0,P1, and BL
; -------------------------------------------------------------------------

        _Disp160 <M0CBase and M1CBase> 1 0 1 0 1
        JMP   @Exiting

DoP0P1M1BL160:

; -------------------------------------------------------------------------
; Displaying P0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <M0CBase> 1 0 1 1 1
        JMP   @Exiting

DoP0M0P1BL160:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1, and BL
; -------------------------------------------------------------------------

        _Disp160 <M1CBase> 1 1 1 0 1
        JMP   @Exiting

DoP0M0P1M1BL160:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1,M1, and BL
; -------------------------------------------------------------------------

        _Disp160 <0FFFFh> 1 1 1 1 1
        JMP   @Exiting

DoNothing160:

; -------------------------------------------------------------------------
; Displaying nothing (playfield only)
; -------------------------------------------------------------------------

        CMP   BYTE PTR Limit,80
        JAE   @MaybeRight160
        _DispLeftNothing160
        JMP   @Exiting
@MaybeRight160:
        CMP   AL,80
        JAE   @OnlyRight160
        _DispNothing160
        JMP   @Exiting
@OnlyRight160:
        _DispRightNothing160
        JMP   @Exiting

;        _Disp160 <P0CBase and P1CBase and M0CBase and m1CBase and BLCBase> 0 0 0 0 0
;        JMP   @Exiting

DoM1160:

; -------------------------------------------------------------------------
; Displaying M1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and M0CBase and BLCBase> 0 0 0 1 0
        JMP   @Exiting

DoM0160:

; -------------------------------------------------------------------------
; Displaying M0
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and M1CBase and BLCBase> 0 1 0 0 0
        JMP   @Exiting

DoM0M1160:

; -------------------------------------------------------------------------
; Displaying M0 and M1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and P1CBase and BLCBase> 0 1 0 1 0
        JMP   @Exiting

DoP1160:

; -------------------------------------------------------------------------
; Displaying P1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M0CBase and M1CBase and BLCBase> 0 0 1 0 0
        JMP   @Exiting

DoM1P1160:

; -------------------------------------------------------------------------
; Displaying P1 and M1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M0CBase and BLCBase> 0 0 1 1 0
        JMP   @Exiting

DoM0P1160:

; -------------------------------------------------------------------------
; Displaying M0 and P1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and M1CBase and BLCBase> 0 1 1 0 0
        JMP   @Exiting

DoM0P1M1160:

; -------------------------------------------------------------------------
; Displaying M0,P1, and M1
; -------------------------------------------------------------------------

        _Disp160 <P0CBase and BLCBase> 0 1 1 1 0
        JMP   @Exiting

DoP0160:

; -------------------------------------------------------------------------
; Displaying P0
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M0CBase and M1CBase and BLCBase> 1 0 0 0 0
        JMP   @Exiting

DoP0M1160:

; -------------------------------------------------------------------------
; Displaying P0 and M1
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M0CBase and BLCBase> 1 0 0 1 0
        JMP   @Exiting

DoP0M0160:

; -------------------------------------------------------------------------
; Displaying P0 and M0
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and M1CBase and BLCBase> 1 1 0 0 0
        JMP   @Exiting

DoP0M0M1160:

; -------------------------------------------------------------------------
; Displaying P0,M0, and M1
; -------------------------------------------------------------------------

        _Disp160 <P1CBase and BLCBase> 1 1 0 1 0
        JMP   @Exiting

DoP0P1160:

; -------------------------------------------------------------------------
; Displaying P0 and P1
; -------------------------------------------------------------------------

        _Disp160 <M0CBase and M1CBase and BLCBase> 1 0 1 0 0
        JMP   @Exiting

DoP0P1M1160:

; -------------------------------------------------------------------------
; Displaying P0,P1, and M1
; -------------------------------------------------------------------------

        _Disp160 <M0CBase and BLCBase> 1 0 1 1 0
        JMP   @Exiting

DoP0M0P1160:

; -------------------------------------------------------------------------
; Displaying P0,M0, and P1
; -------------------------------------------------------------------------

        _Disp160 <M1CBase and BLCBase> 1 1 1 0 0
        JMP   @Exiting

DoP0M0P1M1160:

; -------------------------------------------------------------------------
; Displaying P0,M0,P1, and M1
; -------------------------------------------------------------------------

        _Disp160 <BLCBase> 1 1 1 1 0
;        JMP   @Exiting

; -------------------------------------------------------------------------
ENDIF
;@Exiting160:
;        ADD   DI,DI
@Exiting:

;IF LOWRES EQ 1
;         ADD   DI,DI
;ENDIF

  ; Restore the old Missile0SizeNum/Missile1SizeNum

;        POP   WORD PTR Missile1SizeNum
;        POP   WORD PTR Missile0SizeNum

  ; Unpack collisions and add to the existing ones

        OR    WORD PTR Input_Byte[0],BP
        SHL   BP,2
        OR    WORD PTR Input_Byte[2],BP
        SHL   BP,2
        OR    WORD PTR Input_Byte[4],BP
        SHL   BP,2
        OR    WORD PTR Input_Byte[6],BP
        AND   WORD PTR Input_Byte[0],0C0C0h
        AND   WORD PTR Input_Byte[2],0C0C0h
        AND   WORD PTR Input_Byte[4],0C0C0h
        AND   WORD PTR Input_Byte[6],0C080h
        OR    WORD PTR Input_Byte[0],00100h ; 01100h
        OR    WORD PTR Input_Byte[2],01300h ; 00300h
        OR    WORD PTR Input_Byte[4],00101h
        OR    WORD PTR Input_Byte[6],00101h

  ; Cleanup

        MOV   WORD PTR Addr,DI
        MOV   AX,WORD PTR TIA_Count
        MOV   WORD PTR Old_TIA_Count,AX

  ; Restore BP

        POP   BP
@ExitP:
        RET

Handle_TIA endp
code    ends
        end
